diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-aps-header.cc ns-3.46/src/zigbee/model/zigbee-aps-header.cc
--- ns-3.45/src/zigbee/model/zigbee-aps-header.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-aps-header.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,378 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-aps-header.h"
+
+#include "ns3/address-utils.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+ZigbeeApsHeader::ZigbeeApsHeader()
+{
+    m_frameType = ApsFrameType::APS_DATA;
+    m_deliveryMode = ApsDeliveryMode::APS_UCST;
+    m_ackFormat = false;
+    m_security = false;
+    m_ackRequest = false;
+    m_extHeaderPresent = false;
+}
+
+ZigbeeApsHeader::~ZigbeeApsHeader()
+{
+}
+
+void
+ZigbeeApsHeader::SetFrameType(enum ApsFrameType type)
+{
+    m_frameType = type;
+}
+
+ApsFrameType
+ZigbeeApsHeader::GetFrameType() const
+{
+    return m_frameType;
+}
+
+void
+ZigbeeApsHeader::SetDeliveryMode(enum ApsDeliveryMode mode)
+{
+    m_deliveryMode = mode;
+}
+
+ApsDeliveryMode
+ZigbeeApsHeader::GetDeliveryMode() const
+{
+    return m_deliveryMode;
+}
+
+void
+ZigbeeApsHeader::SetSecurity(bool enabled)
+{
+    m_security = enabled;
+}
+
+bool
+ZigbeeApsHeader::IsSecurityEnabled() const
+{
+    return m_security;
+}
+
+void
+ZigbeeApsHeader::SetAckRequest(bool ack)
+{
+    m_ackRequest = ack;
+}
+
+bool
+ZigbeeApsHeader::IsAckRequested() const
+{
+    return m_ackRequest;
+}
+
+void
+ZigbeeApsHeader::SetExtHeaderPresent(bool present)
+{
+    m_extHeaderPresent = present;
+}
+
+bool
+ZigbeeApsHeader::IsExtHeaderPresent() const
+{
+    return m_extHeaderPresent;
+}
+
+void
+ZigbeeApsHeader::SetDstEndpoint(uint8_t dst)
+{
+    m_dstEndpoint = dst;
+}
+
+uint8_t
+ZigbeeApsHeader::GetDstEndpoint() const
+{
+    return m_dstEndpoint;
+}
+
+void
+ZigbeeApsHeader::SetGroupAddress(uint16_t groupAddress)
+{
+    m_groupAddress = groupAddress;
+}
+
+uint16_t
+ZigbeeApsHeader::GetGroupAddress() const
+{
+    return m_groupAddress;
+}
+
+void
+ZigbeeApsHeader::SetClusterId(uint16_t clusterId)
+{
+    m_clusterId = clusterId;
+}
+
+uint16_t
+ZigbeeApsHeader::GetClusterId() const
+{
+    return m_clusterId;
+}
+
+void
+ZigbeeApsHeader::SetProfileId(uint16_t profileId)
+{
+    m_profileId = profileId;
+}
+
+uint16_t
+ZigbeeApsHeader::GetProfileId() const
+{
+    return m_profileId;
+}
+
+void
+ZigbeeApsHeader::SetSrcEndpoint(uint8_t src)
+{
+    m_srcEndpoint = src;
+}
+
+uint8_t
+ZigbeeApsHeader::GetSrcEndpoint() const
+{
+    return m_srcEndpoint;
+}
+
+void
+ZigbeeApsHeader::SetApsCounter(uint8_t counter)
+{
+    m_apsCounter = counter;
+}
+
+uint8_t
+ZigbeeApsHeader::GetApsCounter() const
+{
+    return m_apsCounter;
+}
+
+void
+ZigbeeApsHeader::Serialize(Buffer::Iterator start) const
+{
+    Buffer::Iterator i = start;
+
+    // Frame control field
+    uint8_t frameControl = (m_frameType & 0x03) | ((m_deliveryMode & 0x03) << 2) |
+                           ((m_ackFormat ? 1 : 0) << 4) | ((m_security ? 1 : 0) << 5) |
+                           ((m_ackRequest ? 1 : 0) << 6) | ((m_extHeaderPresent ? 1 : 0) << 7);
+
+    i.WriteU8(frameControl);
+
+    // Addressing fields
+
+    if (m_deliveryMode == ApsDeliveryMode::APS_UCST || m_deliveryMode == ApsDeliveryMode::APS_BCST)
+    {
+        i.WriteU8(m_dstEndpoint);
+    }
+
+    if (m_deliveryMode == ApsDeliveryMode::APS_GROUP_ADDRESSING)
+    {
+        i.WriteHtolsbU16(m_groupAddress);
+    }
+
+    if (m_frameType == ApsFrameType::APS_DATA || m_frameType == ApsFrameType::APS_ACK)
+    {
+        i.WriteHtolsbU16(m_clusterId);
+        i.WriteHtolsbU16(m_profileId);
+    }
+
+    if (m_frameType == ApsFrameType::APS_DATA)
+    {
+        i.WriteU8(m_srcEndpoint);
+    }
+
+    i.WriteU8(m_apsCounter);
+
+    // Extended Header
+
+    if (m_extHeaderPresent)
+    {
+        // Extended Frame control field
+        uint8_t extFrameControl = (m_fragmentation & 0x03);
+        i.WriteU8(extFrameControl);
+
+        // Block control
+        if (m_fragmentation != ApsFragmentation::NOT_FRAGMENTED)
+        {
+            i.WriteU8(m_blockNumber);
+        }
+        // ACK Bitfield
+        if (m_frameType == ApsFrameType::APS_ACK)
+        {
+            i.WriteU8(m_ackBitfield);
+        }
+    }
+}
+
+uint32_t
+ZigbeeApsHeader::Deserialize(Buffer::Iterator start)
+{
+    Buffer::Iterator i = start;
+
+    uint8_t frameControl = i.ReadU8();
+    m_frameType = static_cast<ApsFrameType>(frameControl & 0x03);
+    m_deliveryMode = static_cast<ApsDeliveryMode>((frameControl >> 2) & 0x03);
+    m_ackFormat = (frameControl >> 4) & 0x01;
+    m_security = (frameControl >> 5) & 0x01;
+    m_ackRequest = (frameControl >> 6) & 0x01;
+    m_extHeaderPresent = (frameControl >> 7) & 0x01;
+
+    // Addressing fields
+
+    if (m_deliveryMode == ApsDeliveryMode::APS_UCST || m_deliveryMode == ApsDeliveryMode::APS_BCST)
+    {
+        m_dstEndpoint = i.ReadU8();
+    }
+
+    if (m_deliveryMode == ApsDeliveryMode::APS_GROUP_ADDRESSING)
+    {
+        m_groupAddress = i.ReadLsbtohU16();
+    }
+
+    if (m_frameType == ApsFrameType::APS_DATA || m_frameType == ApsFrameType::APS_ACK)
+    {
+        m_clusterId = i.ReadLsbtohU16();
+        m_profileId = i.ReadLsbtohU16();
+    }
+
+    if (m_frameType == ApsFrameType::APS_DATA)
+    {
+        m_srcEndpoint = i.ReadU8();
+    }
+
+    m_apsCounter = i.ReadU8();
+
+    // Extended Header
+
+    if (m_extHeaderPresent)
+    {
+        // Extended Frame control field
+        uint8_t extFrameControl = i.ReadU8();
+        m_fragmentation = static_cast<ApsFragmentation>(extFrameControl & 0x03);
+
+        // Block control
+        if (m_fragmentation != ApsFragmentation::NOT_FRAGMENTED)
+        {
+            m_blockNumber = i.ReadU8();
+        }
+        // ACK Bitfield
+        if (m_frameType == ApsFrameType::APS_ACK)
+        {
+            m_ackBitfield = i.ReadU8();
+        }
+    }
+
+    return i.GetDistanceFrom(start);
+}
+
+uint32_t
+ZigbeeApsHeader::GetSerializedSize() const
+{
+    uint8_t totalSize;
+    // See Zigbee Specification r22.1.0
+
+    // Fixed field:
+    // Frame Control (1) + APS Counter (1)
+    totalSize = 2;
+
+    // Variable Fields:
+    // Destination EndPoint field (1) (Section 2.2.5.1.2)
+    if (m_deliveryMode == ApsDeliveryMode::APS_UCST || m_deliveryMode == ApsDeliveryMode::APS_BCST)
+    {
+        totalSize += 1;
+    }
+
+    // Group Address field (2) (Section 2.2.5.1.3)
+    if (m_deliveryMode == ApsDeliveryMode::APS_GROUP_ADDRESSING)
+    {
+        totalSize += 2;
+    }
+
+    // Cluster identifier field and Profile identifier field (4)
+    // (Sections 2.2.5.1.4 and 2.2.5.15)
+    if (m_frameType == ApsFrameType::APS_DATA || m_frameType == ApsFrameType::APS_ACK)
+    {
+        totalSize += 4;
+    }
+
+    // Source Endpoint field  (1) (Section  2.2.5.1.6)
+    if (m_frameType == ApsFrameType::APS_DATA)
+    {
+        totalSize += 1;
+    }
+
+    // Extended header sub-frame (variable)
+    if (m_extHeaderPresent)
+    {
+        // Extended Frame control field (1)
+        totalSize += 1;
+
+        // Block control (1)
+        if (m_fragmentation != ApsFragmentation::NOT_FRAGMENTED)
+        {
+            totalSize += 1;
+        }
+        // ACK Bitfield
+        if (m_frameType == ApsFrameType::APS_ACK)
+        {
+            totalSize += 1;
+        }
+    }
+
+    return totalSize;
+}
+
+TypeId
+ZigbeeApsHeader::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::zigbee::ZigbeeApsHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Zigbee")
+                            .AddConstructor<ZigbeeApsHeader>();
+    return tid;
+}
+
+TypeId
+ZigbeeApsHeader::GetInstanceTypeId() const
+{
+    return GetTypeId();
+}
+
+void
+ZigbeeApsHeader::Print(std::ostream& os) const
+{
+    // TODO:
+    /* os << "\nAPS Frame Control = " << std::hex << std::showbase << static_cast<uint32_t>(
+         (m_frameType & 0x03) |
+         ((m_deliveryMode & 0x03) << 2) |
+         ((m_ackFormat ? 1 : 0) << 4) |
+         ((m_security ? 1 : 0) << 5) |
+         ((m_ackRequest ? 1 : 0) << 6) |
+         ((m_extHeader ? 1 : 0) << 7));
+
+     os << " | Dst EP = " << static_cast<uint32_t>(m_dstEndpoint)
+        << " | Src EP = " << static_cast<uint32_t>(m_srcEndpoint)
+        << " | Cluster ID = " << m_clusterId
+        << " | Profile ID = " << m_profileId
+        << " | Counter = " << static_cast<uint32_t>(m_counter);
+     os << "\n";*/
+}
+
+} // namespace zigbee
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-aps-header.h ns-3.46/src/zigbee/model/zigbee-aps-header.h
--- ns-3.45/src/zigbee/model/zigbee-aps-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-aps-header.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,278 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_APS_HEADER_H
+#define ZIGBEE_APS_HEADER_H
+
+#include "ns3/header.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+/**
+ *  @ingroup zigbee
+ *
+ *  Values of the Frame Type Sub-Field.
+ *  Zigbee Specification r22.1.0, Table 2-20
+ */
+enum ApsFrameType : uint8_t
+{
+    APS_DATA = 0x00,
+    APS_COMMAND = 0x01,
+    APS_ACK = 0x02,
+    APS_INTERPAN_APS = 0x03
+};
+
+/**
+ *  @ingroup zigbee
+ *
+ *  Values of the Delivery Mode Sub-Field.
+ *  Zigbee Specification r22.1.0, Table 2-21
+ */
+enum ApsDeliveryMode : uint8_t
+{
+    APS_UCST = 0x00,
+    APS_BCST = 0x02,
+    APS_GROUP_ADDRESSING = 0x03
+};
+
+/**
+ *  @ingroup zigbee
+ *
+ *  Table 2-22 Values of the Fragmentation Sub-Field
+ *  Zigbee Specification r22.1.0, Table 2-22
+ */
+enum ApsFragmentation : uint8_t
+{
+    NOT_FRAGMENTED = 0x00,
+    FIRST_FRAGMENT = 0x01,
+    OTHER_FRAGMENT = 0x02
+};
+
+/**
+ * @ingroup zigbee
+ *
+ * Defines the APS header use by data transfer and commands issued from
+ * the APS layer. Zigbee Specification r22.1.0, Section 2.2.5.1.
+ *
+ */
+class ZigbeeApsHeader : public Header
+{
+  public:
+    ZigbeeApsHeader();
+    ~ZigbeeApsHeader() override;
+
+    /**
+     * Set the Frame type defined in the APS layer
+     *
+     * @param frameType The frame type to set on the header
+     */
+    void SetFrameType(enum ApsFrameType frameType);
+
+    /**
+     * Get the frame time present in the header
+     *
+     * @return ApsFrameType
+     */
+    ApsFrameType GetFrameType() const;
+
+    /**
+     * Defines the mode in which this frame should be transmitted.
+     *
+     * @param mode The delivery mode to set on the APS header
+     */
+    void SetDeliveryMode(enum ApsDeliveryMode mode);
+
+    /**
+     * Get the transmission mode set on the header.
+     *
+     * @return ApsDeliveryMode The delivery mode of the header
+     */
+    ApsDeliveryMode GetDeliveryMode() const;
+
+    /**
+     * Set whether or not security should be used to transmit
+     * the frame.
+     *
+     * @param enabled True if security should be used
+     */
+    void SetSecurity(bool enabled);
+
+    /**
+     * Returns whether or not security is enabled for the present frame.alignas
+     *
+     * @return True if security is enabled for the frame.
+     */
+    bool IsSecurityEnabled() const;
+
+    /**
+     * Set the acknowledment flag in the APS header.
+     *
+     * @param request True if the frame should be acknowledged
+     */
+    void SetAckRequest(bool request);
+
+    /**
+     * Indicates if the present frame requires acknowledgment.
+     *
+     * @return True if the frame requires acknowledgment
+     */
+    bool IsAckRequested() const;
+
+    /**
+     * Enables or disables the usage of the extended header.
+     * Only used when fragmentation is used.
+     *
+     * @param present True if the extended header (fragmentation) is present.
+     */
+    void SetExtHeaderPresent(bool present);
+
+    /**
+     * Indicates whether or not the extended header is present in the frame.
+     * @return True if the extended header is present.
+     */
+    bool IsExtHeaderPresent() const;
+
+    /**
+     * Set the Bitmap representing the framecontrol portion of the APS header.
+     *
+     * @param frameControl The bitmap representing the framecontrol portion.
+     */
+    void SetFrameControl(uint8_t frameControl);
+
+    /**
+     * Get the frame control portion (bitmap) of the APS header.
+     *
+     * @return The frame control portion of the APS header.
+     */
+    uint8_t GetFrameControl() const;
+
+    /**
+     * Set the destination endpoint in the APS header.
+     *
+     * @param endpoint The destination endpoint.
+     */
+    void SetDstEndpoint(uint8_t endpoint);
+
+    /**
+     * Get the destination endpoint in the APS header.
+     *
+     * @return The destination endpoint.
+     */
+    uint8_t GetDstEndpoint() const;
+
+    /**
+     * Set the group address in the APS header.
+     *
+     * @param groupAddress The group address to set.
+     */
+    void SetGroupAddress(uint16_t groupAddress);
+
+    /**
+     * Get the group address in the APS header.
+     *
+     * @return The group address.
+     */
+    uint16_t GetGroupAddress() const;
+
+    /**
+     * Set the cluster id in the APS header.
+     *
+     * @param clusterId The cluster id
+     */
+    void SetClusterId(uint16_t clusterId);
+
+    /**
+     * Get the cluster id in the APS header.
+     * @return The cluster id.
+     */
+    uint16_t GetClusterId() const;
+
+    /**
+     * Set the profile ID in the APS header.
+     *
+     * @param profileId The profile ID.
+     */
+    void SetProfileId(uint16_t profileId);
+
+    /**
+     * Get the profile ID in the APS header.
+     * @return The profile ID.
+     */
+    uint16_t GetProfileId() const;
+
+    /**
+     * Set the source endpoint in the APS header.
+     *
+     * @param endpoint The source endpoint.
+     */
+    void SetSrcEndpoint(uint8_t endpoint);
+
+    /**
+     * Get the source endpoint in the APS header.
+     * @return The source endpoint.
+     */
+    uint8_t GetSrcEndpoint() const;
+
+    /**
+     * Set the value of the APS counter in the APS header.
+     * @param counter The APS counter value.
+     */
+    void SetApsCounter(uint8_t counter);
+
+    /**
+     * Get the APS counter value present in the APS header.
+     * @return The APS counter value.
+     */
+    uint8_t GetApsCounter() const;
+
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+    TypeId GetInstanceTypeId() const override;
+
+    void Serialize(Buffer::Iterator start) const override;
+    uint32_t Deserialize(Buffer::Iterator start) override;
+    uint32_t GetSerializedSize() const override;
+    void Print(std::ostream& os) const override;
+
+  private:
+    // Frame Control field bits
+    ApsFrameType m_frameType;       //!< Frame control field: Frame type
+    ApsDeliveryMode m_deliveryMode; //!< Frame control field: Delivery mode
+    bool m_ackFormat;               //!< Frame control field: Acknowledgment format
+    bool m_security;                //!< Frame control field: Security
+    bool m_ackRequest;              //!< Frame control field: Acknowledge requested
+    bool m_extHeaderPresent;        //!< Frame control field: Extended header present
+
+    // Addressing fields
+    uint8_t m_dstEndpoint;   //!< Addressing field: Destination endpoint.
+    uint16_t m_groupAddress; //!< Addressing field: Group or 16-bit address.
+    uint16_t m_clusterId;    //!< Addressing field: Cluster ID.
+    uint16_t m_profileId;    //!< Addressing field: Profile ID.
+    uint8_t m_srcEndpoint;   //!< Addressing field: Source endpoint.
+
+    uint8_t m_apsCounter; //!< APS counter field
+
+    // Extended header fields
+    ApsFragmentation m_fragmentation; //!< Extended header field: Fragmentation block type
+    uint8_t m_blockNumber;            //!< Extended header field: Block number
+    uint8_t m_ackBitfield;            //!< Extended header field: Acknowledgement bit field
+};
+
+} // namespace zigbee
+} // namespace ns3
+
+#endif // ZIGBEE_APS_HEADER_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-aps-tables.cc ns-3.46/src/zigbee/model/zigbee-aps-tables.cc
--- ns-3.45/src/zigbee/model/zigbee-aps-tables.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-aps-tables.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,278 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-aps-tables.h"
+
+#include "ns3/log.h"
+#include "ns3/pointer.h"
+#include "ns3/simulator.h"
+
+#include <algorithm>
+#include <iomanip>
+
+namespace ns3
+{
+namespace zigbee
+{
+
+NS_LOG_COMPONENT_DEFINE("ZigbeeApsTables");
+
+/***********************************************************
+ *                Source Binding Entry
+ ***********************************************************/
+
+SrcBindingEntry::SrcBindingEntry()
+{
+}
+
+SrcBindingEntry::SrcBindingEntry(Mac64Address address, uint8_t endPoint, uint16_t clusterId)
+{
+    m_srcAddr = address;
+    m_srcEndPoint = endPoint;
+    m_clusterId = clusterId;
+}
+
+SrcBindingEntry::~SrcBindingEntry()
+{
+}
+
+void
+SrcBindingEntry::SetSrcAddress(Mac64Address address)
+{
+    m_srcAddr = address;
+}
+
+void
+SrcBindingEntry::SetSrcEndPoint(uint8_t endPoint)
+{
+    m_srcEndPoint = endPoint;
+}
+
+void
+SrcBindingEntry::SetClusterId(uint16_t clusterId)
+{
+    m_clusterId = clusterId;
+}
+
+Mac64Address
+SrcBindingEntry::GetSrcAddress() const
+{
+    return m_srcAddr;
+}
+
+uint8_t
+SrcBindingEntry::GetSrcEndPoint() const
+{
+    return m_srcEndPoint;
+}
+
+uint16_t
+SrcBindingEntry::GetClusterId() const
+{
+    return m_clusterId;
+}
+
+/***********************************************************
+ *                Destination Binding Entry
+ ***********************************************************/
+
+DstBindingEntry::DstBindingEntry()
+{
+}
+
+DstBindingEntry::~DstBindingEntry()
+{
+}
+
+void
+DstBindingEntry::SetDstAddrMode(ApsDstAddressModeBind mode)
+{
+    m_dstAddrMode = mode;
+}
+
+void
+DstBindingEntry::SetDstAddr16(Mac16Address address)
+{
+    m_dstAddr16 = address;
+}
+
+void
+DstBindingEntry::SetDstAddr64(Mac64Address address)
+{
+    m_dstAddr64 = address;
+}
+
+void
+DstBindingEntry::SetDstEndPoint(uint8_t endPoint)
+{
+    m_dstEndPoint = endPoint;
+}
+
+ApsDstAddressModeBind
+DstBindingEntry::GetDstAddrMode() const
+{
+    return m_dstAddrMode;
+}
+
+Mac16Address
+DstBindingEntry::GetDstAddr16() const
+{
+    return m_dstAddr16;
+}
+
+Mac64Address
+DstBindingEntry::GetDstAddr64() const
+{
+    return m_dstAddr64;
+}
+
+uint8_t
+DstBindingEntry::GetDstEndPoint() const
+{
+    return m_dstEndPoint;
+}
+
+/***********************************************************
+ *                Binding Table
+ ***********************************************************/
+
+BindingTable::BindingTable()
+{
+    m_maxSrcEntries = 10;
+    m_maxDstEntries = 10;
+}
+
+bool
+BindingTable::CompareDestinations(const DstBindingEntry& first, const DstBindingEntry& second)
+{
+    if (first.GetDstAddrMode() == ApsDstAddressModeBind::GROUP_ADDR_DST_ENDPOINT_NOT_PRESENT)
+    {
+        // Group Addressing
+        if ((first.GetDstAddr16() == second.GetDstAddr16()) &&
+            (first.GetDstEndPoint() == second.GetDstEndPoint()))
+        {
+            return true;
+        }
+    }
+    else if (first.GetDstAddrMode() == ApsDstAddressModeBind::DST_ADDR64_DST_ENDPOINT_PRESENT)
+    {
+        // IEEE Addressing
+        if ((first.GetDstAddr64() == second.GetDstAddr64()) &&
+            (first.GetDstEndPoint() == second.GetDstEndPoint()))
+        {
+            return true;
+        }
+    }
+    return false;
+}
+
+bool
+BindingTable::CompareSources(const SrcBindingEntry& first, const SrcBindingEntry& second)
+{
+    return ((first.GetSrcAddress() == second.GetSrcAddress()) &&
+            (first.GetSrcEndPoint() == second.GetSrcEndPoint()) &&
+            (first.GetClusterId() == second.GetClusterId()));
+}
+
+BindingTableStatus
+BindingTable::Bind(const SrcBindingEntry& src, const DstBindingEntry& dst)
+{
+    for (auto& entry : m_bindingTable)
+    {
+        if (CompareSources(src, entry.first))
+        {
+            // The source exist, now check if the destination exist
+            for (const auto& destination : entry.second)
+            {
+                if (CompareDestinations(dst, destination))
+                {
+                    NS_LOG_WARN("Entry already exist in binding table");
+                    return BindingTableStatus::ENTRY_EXISTS;
+                }
+            }
+            // Add the new destination bound to the source
+            if (entry.second.size() >= m_maxDstEntries)
+            {
+                NS_LOG_WARN("Binding Table full, max destination entries (" << m_maxDstEntries
+                                                                            << ") reached");
+                return BindingTableStatus::TABLE_FULL;
+            }
+            else
+            {
+                entry.second.emplace_back(dst);
+                return BindingTableStatus::BOUND;
+            }
+        }
+    }
+
+    if (m_bindingTable.size() >= m_maxSrcEntries)
+    {
+        NS_LOG_WARN("Binding Table full, max source entries (" << m_maxSrcEntries << ") reached");
+        return BindingTableStatus::TABLE_FULL;
+    }
+    else
+    {
+        // New source with its first destination
+        m_bindingTable.emplace_back(src, std::vector<DstBindingEntry>{dst});
+        return BindingTableStatus::BOUND;
+    }
+}
+
+BindingTableStatus
+BindingTable::Unbind(const SrcBindingEntry& src, const DstBindingEntry& dst)
+{
+    for (auto it = m_bindingTable.begin(); it != m_bindingTable.end(); ++it)
+    {
+        if (CompareSources(src, it->first))
+        {
+            // The source exists, now check if the destination exists
+            auto& destinations = it->second;
+            for (auto destIt = destinations.begin(); destIt != destinations.end(); ++destIt)
+            {
+                if (CompareDestinations(dst, *destIt))
+                {
+                    // Destination found, remove it
+                    destinations.erase(destIt);
+
+                    // If no destinations left, remove the source entry
+                    if (destinations.empty())
+                    {
+                        m_bindingTable.erase(it);
+                    }
+                    // Successfully unbound
+                    return BindingTableStatus::UNBOUND;
+                }
+            }
+            // Destination not found
+            NS_LOG_WARN("Cannot unbind, destination entry do not exist");
+            return BindingTableStatus::ENTRY_NOT_FOUND;
+        }
+    }
+    // Source not found
+    NS_LOG_WARN("Cannot unbind, source entry do not exist");
+    return BindingTableStatus::ENTRY_NOT_FOUND;
+}
+
+bool
+BindingTable::LookUpEntries(const SrcBindingEntry& src, std::vector<DstBindingEntry>& dstEntries)
+{
+    for (auto& entry : m_bindingTable)
+    {
+        if (CompareSources(src, entry.first))
+        {
+            // The source entry exist, return all the dst entries.
+            dstEntries = entry.second;
+            return true;
+        }
+    }
+    return false;
+}
+
+} // namespace zigbee
+} // namespace ns3
